#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 117
#define LARGE_STATE_COUNT 2
#define SYMBOL_COUNT 59
#define ALIAS_COUNT 2
#define TOKEN_COUNT 30
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 2
#define MAX_ALIAS_SEQUENCE_LENGTH 8
#define PRODUCTION_ID_COUNT 4

enum {
  anon_sym_LBRACE = 1,
  anon_sym_COMMA = 2,
  anon_sym_RBRACE = 3,
  anon_sym_COLON = 4,
  anon_sym_LBRACK = 5,
  anon_sym_RBRACK = 6,
  anon_sym_DQUOTE = 7,
  aux_sym_string_content_token1 = 8,
  sym_escape_sequence = 9,
  sym_number = 10,
  sym_true = 11,
  sym_false = 12,
  sym_null = 13,
  sym_comment = 14,
  sym_rule_constant_exactly = 15,
  sym_rule_constant_prefix = 16,
  sym_rule_constant_suffix = 17,
  sym_rule_constant_equals_ignore_case = 18,
  sym_rule_constant_wildcard = 19,
  sym_rule_constant_anything_but = 20,
  sym_rule_constant_numeric = 21,
  sym_rule_constant_cidr = 22,
  sym_rule_constant_exists = 23,
  sym_rule_constant_or = 24,
  anon_sym_DQUOTE_LT_DQUOTE = 25,
  anon_sym_DQUOTE_GT_DQUOTE = 26,
  anon_sym_DQUOTE_LT_EQ_DQUOTE = 27,
  anon_sym_DQUOTE_GT_EQ_DQUOTE = 28,
  sym_rule_numeric_equality_sign = 29,
  sym_document = 30,
  sym__value = 31,
  sym_object = 32,
  sym_pair = 33,
  sym_array = 34,
  sym_string = 35,
  sym_string_content = 36,
  sym__rule_value_array = 37,
  sym_rule_value_matching = 38,
  sym_rule_exactly_matching = 39,
  sym_rule_prefix_matching = 40,
  sym_rule_suffix_matching = 41,
  sym_rule_equals_ignore_case_matching = 42,
  sym_rule_wildcard_matching = 43,
  sym_rule_anything_but_matching = 44,
  sym_rule_numeric_comparison_sign = 45,
  sym_rule_numeric_matching = 46,
  sym_rule_ip_address_matching = 47,
  sym_rule_exists_matching = 48,
  sym_rule_or_matching = 49,
  sym_boolean = 50,
  aux_sym_object_repeat1 = 51,
  aux_sym_array_repeat1 = 52,
  aux_sym_string_content_repeat1 = 53,
  aux_sym__rule_value_array_repeat1 = 54,
  aux_sym__rule_value_array_repeat2 = 55,
  aux_sym_rule_numeric_matching_repeat1 = 56,
  aux_sym_rule_or_matching_repeat1 = 57,
  aux_sym_rule_or_matching_repeat2 = 58,
  alias_sym_rule_constant_value = 59,
  alias_sym_rule_nested_prefix_matching = 60,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_COLON] = ":",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_content_token1] = "string_content_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_number] = "number",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_comment] = "comment",
  [sym_rule_constant_exactly] = "rule_constant_exactly",
  [sym_rule_constant_prefix] = "rule_constant_prefix",
  [sym_rule_constant_suffix] = "rule_constant_suffix",
  [sym_rule_constant_equals_ignore_case] = "rule_constant_equals_ignore_case",
  [sym_rule_constant_wildcard] = "rule_constant_wildcard",
  [sym_rule_constant_anything_but] = "rule_constant_anything_but",
  [sym_rule_constant_numeric] = "rule_constant_numeric",
  [sym_rule_constant_cidr] = "rule_constant_cidr",
  [sym_rule_constant_exists] = "rule_constant_exists",
  [sym_rule_constant_or] = "rule_constant_or",
  [anon_sym_DQUOTE_LT_DQUOTE] = "\"<\"",
  [anon_sym_DQUOTE_GT_DQUOTE] = "\">\"",
  [anon_sym_DQUOTE_LT_EQ_DQUOTE] = "\"<=\"",
  [anon_sym_DQUOTE_GT_EQ_DQUOTE] = "\">=\"",
  [sym_rule_numeric_equality_sign] = "rule_numeric_equality_sign",
  [sym_document] = "document",
  [sym__value] = "_value",
  [sym_object] = "object",
  [sym_pair] = "pair",
  [sym_array] = "array",
  [sym_string] = "string",
  [sym_string_content] = "string_content",
  [sym__rule_value_array] = "array",
  [sym_rule_value_matching] = "rule_value_matching",
  [sym_rule_exactly_matching] = "rule_exactly_matching",
  [sym_rule_prefix_matching] = "rule_prefix_matching",
  [sym_rule_suffix_matching] = "rule_suffix_matching",
  [sym_rule_equals_ignore_case_matching] = "rule_equals_ignore_case_matching",
  [sym_rule_wildcard_matching] = "rule_wildcard_matching",
  [sym_rule_anything_but_matching] = "rule_anything_but_matching",
  [sym_rule_numeric_comparison_sign] = "rule_numeric_comparison_sign",
  [sym_rule_numeric_matching] = "rule_numeric_matching",
  [sym_rule_ip_address_matching] = "rule_ip_address_matching",
  [sym_rule_exists_matching] = "rule_exists_matching",
  [sym_rule_or_matching] = "rule_or_matching",
  [sym_boolean] = "boolean",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_string_content_repeat1] = "string_content_repeat1",
  [aux_sym__rule_value_array_repeat1] = "_rule_value_array_repeat1",
  [aux_sym__rule_value_array_repeat2] = "_rule_value_array_repeat2",
  [aux_sym_rule_numeric_matching_repeat1] = "rule_numeric_matching_repeat1",
  [aux_sym_rule_or_matching_repeat1] = "rule_or_matching_repeat1",
  [aux_sym_rule_or_matching_repeat2] = "rule_or_matching_repeat2",
  [alias_sym_rule_constant_value] = "rule_constant_value",
  [alias_sym_rule_nested_prefix_matching] = "rule_nested_prefix_matching",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_string_content_token1] = aux_sym_string_content_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_number] = sym_number,
  [sym_true] = sym_true,
  [sym_false] = sym_false,
  [sym_null] = sym_null,
  [sym_comment] = sym_comment,
  [sym_rule_constant_exactly] = sym_rule_constant_exactly,
  [sym_rule_constant_prefix] = sym_rule_constant_prefix,
  [sym_rule_constant_suffix] = sym_rule_constant_suffix,
  [sym_rule_constant_equals_ignore_case] = sym_rule_constant_equals_ignore_case,
  [sym_rule_constant_wildcard] = sym_rule_constant_wildcard,
  [sym_rule_constant_anything_but] = sym_rule_constant_anything_but,
  [sym_rule_constant_numeric] = sym_rule_constant_numeric,
  [sym_rule_constant_cidr] = sym_rule_constant_cidr,
  [sym_rule_constant_exists] = sym_rule_constant_exists,
  [sym_rule_constant_or] = sym_rule_constant_or,
  [anon_sym_DQUOTE_LT_DQUOTE] = anon_sym_DQUOTE_LT_DQUOTE,
  [anon_sym_DQUOTE_GT_DQUOTE] = anon_sym_DQUOTE_GT_DQUOTE,
  [anon_sym_DQUOTE_LT_EQ_DQUOTE] = anon_sym_DQUOTE_LT_EQ_DQUOTE,
  [anon_sym_DQUOTE_GT_EQ_DQUOTE] = anon_sym_DQUOTE_GT_EQ_DQUOTE,
  [sym_rule_numeric_equality_sign] = sym_rule_numeric_equality_sign,
  [sym_document] = sym_document,
  [sym__value] = sym__value,
  [sym_object] = sym_object,
  [sym_pair] = sym_pair,
  [sym_array] = sym_array,
  [sym_string] = sym_string,
  [sym_string_content] = sym_string_content,
  [sym__rule_value_array] = sym_array,
  [sym_rule_value_matching] = sym_rule_value_matching,
  [sym_rule_exactly_matching] = sym_rule_exactly_matching,
  [sym_rule_prefix_matching] = sym_rule_prefix_matching,
  [sym_rule_suffix_matching] = sym_rule_suffix_matching,
  [sym_rule_equals_ignore_case_matching] = sym_rule_equals_ignore_case_matching,
  [sym_rule_wildcard_matching] = sym_rule_wildcard_matching,
  [sym_rule_anything_but_matching] = sym_rule_anything_but_matching,
  [sym_rule_numeric_comparison_sign] = sym_rule_numeric_comparison_sign,
  [sym_rule_numeric_matching] = sym_rule_numeric_matching,
  [sym_rule_ip_address_matching] = sym_rule_ip_address_matching,
  [sym_rule_exists_matching] = sym_rule_exists_matching,
  [sym_rule_or_matching] = sym_rule_or_matching,
  [sym_boolean] = sym_boolean,
  [aux_sym_object_repeat1] = aux_sym_object_repeat1,
  [aux_sym_array_repeat1] = aux_sym_array_repeat1,
  [aux_sym_string_content_repeat1] = aux_sym_string_content_repeat1,
  [aux_sym__rule_value_array_repeat1] = aux_sym__rule_value_array_repeat1,
  [aux_sym__rule_value_array_repeat2] = aux_sym__rule_value_array_repeat2,
  [aux_sym_rule_numeric_matching_repeat1] = aux_sym_rule_numeric_matching_repeat1,
  [aux_sym_rule_or_matching_repeat1] = aux_sym_rule_or_matching_repeat1,
  [aux_sym_rule_or_matching_repeat2] = aux_sym_rule_or_matching_repeat2,
  [alias_sym_rule_constant_value] = alias_sym_rule_constant_value,
  [alias_sym_rule_nested_prefix_matching] = alias_sym_rule_nested_prefix_matching,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_content_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_constant_exactly] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_constant_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_constant_suffix] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_constant_equals_ignore_case] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_constant_wildcard] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_constant_anything_but] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_constant_numeric] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_constant_cidr] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_constant_exists] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_constant_or] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE_LT_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_GT_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_LT_EQ_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE_GT_EQ_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym_rule_numeric_equality_sign] = {
    .visible = true,
    .named = true,
  },
  [sym_document] = {
    .visible = true,
    .named = true,
  },
  [sym__value] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string_content] = {
    .visible = true,
    .named = true,
  },
  [sym__rule_value_array] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_value_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_exactly_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_prefix_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_suffix_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_equals_ignore_case_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_wildcard_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_anything_but_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_numeric_comparison_sign] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_numeric_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_ip_address_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_exists_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_rule_or_matching] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_content_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__rule_value_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__rule_value_array_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rule_numeric_matching_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rule_or_matching_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rule_or_matching_repeat2] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_rule_constant_value] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_rule_nested_prefix_matching] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_key = 1,
  field_value = 2,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_key] = "key",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_key, 0},
    {field_value, 2},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [2] = {
    [0] = alias_sym_rule_constant_value,
  },
  [3] = {
    [3] = alias_sym_rule_nested_prefix_matching,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_string, 2,
    sym_string,
    alias_sym_rule_constant_value,
  sym_rule_prefix_matching, 2,
    sym_rule_prefix_matching,
    alias_sym_rule_nested_prefix_matching,
  0,
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(107);
      if (lookahead == '"') ADVANCE(115);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(26);
      if (lookahead == ',') ADVANCE(109);
      if (lookahead == '.') ADVANCE(103);
      if (lookahead == '/') ADVANCE(20);
      if (lookahead == '0') ADVANCE(123);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == '\\') ADVANCE(102);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == 'f') ADVANCE(28);
      if (lookahead == 'n') ADVANCE(91);
      if (lookahead == 't') ADVANCE(77);
      if (lookahead == '{') ADVANCE(108);
      if (lookahead == '}') ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(106)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(12)
      if (lookahead == '"') ADVANCE(114);
      if (lookahead == '/') ADVANCE(116);
      if (lookahead == '\\') ADVANCE(102);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(119);
      if (lookahead != 0) ADVANCE(121);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(145);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(143);
      END_STATE();
    case 4:
      if (lookahead == '"') ADVANCE(144);
      END_STATE();
    case 5:
      if (lookahead == '"') ADVANCE(137);
      END_STATE();
    case 6:
      if (lookahead == '"') ADVANCE(138);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(136);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(142);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(140);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(141);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(139);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(114);
      if (lookahead == '/') ADVANCE(20);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(12)
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(114);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(26);
      if (lookahead == '.') ADVANCE(103);
      if (lookahead == '/') ADVANCE(20);
      if (lookahead == '0') ADVANCE(123);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == 'f') ADVANCE(28);
      if (lookahead == 'n') ADVANCE(91);
      if (lookahead == 't') ADVANCE(77);
      if (lookahead == '{') ADVANCE(108);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(13)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(27);
      if (lookahead == '/') ADVANCE(20);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(14)
      END_STATE();
    case 15:
      if (lookahead == '"') ADVANCE(146);
      if (lookahead == '=') ADVANCE(18);
      END_STATE();
    case 16:
      if (lookahead == '"') ADVANCE(150);
      END_STATE();
    case 17:
      if (lookahead == '"') ADVANCE(147);
      if (lookahead == '=') ADVANCE(19);
      END_STATE();
    case 18:
      if (lookahead == '"') ADVANCE(148);
      END_STATE();
    case 19:
      if (lookahead == '"') ADVANCE(149);
      END_STATE();
    case 20:
      if (lookahead == '*') ADVANCE(22);
      if (lookahead == '/') ADVANCE(135);
      END_STATE();
    case 21:
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '/') ADVANCE(134);
      if (lookahead != 0) ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == '*') ADVANCE(21);
      if (lookahead != 0) ADVANCE(22);
      END_STATE();
    case 23:
      if (lookahead == '-') ADVANCE(33);
      END_STATE();
    case 24:
      if (lookahead == '-') ADVANCE(36);
      END_STATE();
    case 25:
      if (lookahead == '-') ADVANCE(56);
      END_STATE();
    case 26:
      if (lookahead == '0') ADVANCE(124);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      END_STATE();
    case 27:
      if (lookahead == '<') ADVANCE(15);
      if (lookahead == '=') ADVANCE(16);
      if (lookahead == '>') ADVANCE(17);
      END_STATE();
    case 28:
      if (lookahead == 'a') ADVANCE(60);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(35);
      if (lookahead == 'i') ADVANCE(82);
      END_STATE();
    case 30:
      if (lookahead == 'a') ADVANCE(76);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(64);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(84);
      END_STATE();
    case 33:
      if (lookahead == 'b') ADVANCE(93);
      END_STATE();
    case 34:
      if (lookahead == 'c') ADVANCE(30);
      END_STATE();
    case 35:
      if (lookahead == 'c') ADVANCE(87);
      END_STATE();
    case 36:
      if (lookahead == 'c') ADVANCE(32);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(8);
      END_STATE();
    case 38:
      if (lookahead == 'd') ADVANCE(34);
      END_STATE();
    case 39:
      if (lookahead == 'd') ADVANCE(75);
      END_STATE();
    case 40:
      if (lookahead == 'd') ADVANCE(9);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(131);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(132);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(47);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(24);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(78);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(11);
      END_STATE();
    case 47:
      if (lookahead == 'f') ADVANCE(54);
      END_STATE();
    case 48:
      if (lookahead == 'f') ADVANCE(59);
      END_STATE();
    case 49:
      if (lookahead == 'f') ADVANCE(48);
      END_STATE();
    case 50:
      if (lookahead == 'g') ADVANCE(23);
      END_STATE();
    case 51:
      if (lookahead == 'g') ADVANCE(69);
      END_STATE();
    case 52:
      if (lookahead == 'h') ADVANCE(55);
      END_STATE();
    case 53:
      if (lookahead == 'i') ADVANCE(39);
      END_STATE();
    case 54:
      if (lookahead == 'i') ADVANCE(95);
      END_STATE();
    case 55:
      if (lookahead == 'i') ADVANCE(68);
      END_STATE();
    case 56:
      if (lookahead == 'i') ADVANCE(51);
      END_STATE();
    case 57:
      if (lookahead == 'i') ADVANCE(63);
      END_STATE();
    case 58:
      if (lookahead == 'i') ADVANCE(37);
      END_STATE();
    case 59:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 60:
      if (lookahead == 'l') ADVANCE(83);
      END_STATE();
    case 61:
      if (lookahead == 'l') ADVANCE(133);
      END_STATE();
    case 62:
      if (lookahead == 'l') ADVANCE(98);
      END_STATE();
    case 63:
      if (lookahead == 'l') ADVANCE(38);
      END_STATE();
    case 64:
      if (lookahead == 'l') ADVANCE(80);
      END_STATE();
    case 65:
      if (lookahead == 'l') ADVANCE(61);
      END_STATE();
    case 66:
      if (lookahead == 'm') ADVANCE(45);
      END_STATE();
    case 67:
      if (lookahead == 'n') ADVANCE(97);
      END_STATE();
    case 68:
      if (lookahead == 'n') ADVANCE(50);
      END_STATE();
    case 69:
      if (lookahead == 'n') ADVANCE(71);
      END_STATE();
    case 70:
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 71:
      if (lookahead == 'o') ADVANCE(79);
      END_STATE();
    case 72:
      if (lookahead == 'q') ADVANCE(94);
      if (lookahead == 'x') ADVANCE(29);
      END_STATE();
    case 73:
      if (lookahead == 'r') ADVANCE(43);
      END_STATE();
    case 74:
      if (lookahead == 'r') ADVANCE(2);
      END_STATE();
    case 75:
      if (lookahead == 'r') ADVANCE(3);
      END_STATE();
    case 76:
      if (lookahead == 'r') ADVANCE(40);
      END_STATE();
    case 77:
      if (lookahead == 'r') ADVANCE(92);
      END_STATE();
    case 78:
      if (lookahead == 'r') ADVANCE(58);
      END_STATE();
    case 79:
      if (lookahead == 'r') ADVANCE(44);
      END_STATE();
    case 80:
      if (lookahead == 's') ADVANCE(25);
      END_STATE();
    case 81:
      if (lookahead == 's') ADVANCE(4);
      END_STATE();
    case 82:
      if (lookahead == 's') ADVANCE(86);
      END_STATE();
    case 83:
      if (lookahead == 's') ADVANCE(42);
      END_STATE();
    case 84:
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 85:
      if (lookahead == 't') ADVANCE(52);
      END_STATE();
    case 86:
      if (lookahead == 't') ADVANCE(81);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(62);
      END_STATE();
    case 88:
      if (lookahead == 't') ADVANCE(10);
      END_STATE();
    case 89:
      if (lookahead == 'u') ADVANCE(66);
      END_STATE();
    case 90:
      if (lookahead == 'u') ADVANCE(49);
      END_STATE();
    case 91:
      if (lookahead == 'u') ADVANCE(65);
      END_STATE();
    case 92:
      if (lookahead == 'u') ADVANCE(41);
      END_STATE();
    case 93:
      if (lookahead == 'u') ADVANCE(88);
      END_STATE();
    case 94:
      if (lookahead == 'u') ADVANCE(31);
      END_STATE();
    case 95:
      if (lookahead == 'x') ADVANCE(5);
      END_STATE();
    case 96:
      if (lookahead == 'x') ADVANCE(6);
      END_STATE();
    case 97:
      if (lookahead == 'y') ADVANCE(85);
      END_STATE();
    case 98:
      if (lookahead == 'y') ADVANCE(7);
      END_STATE();
    case 99:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(104);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 100:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(127);
      END_STATE();
    case 101:
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(128);
      END_STATE();
    case 102:
      if (lookahead == '"' ||
          lookahead == '/' ||
          lookahead == '\\' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't' ||
          lookahead == 'u') ADVANCE(122);
      END_STATE();
    case 103:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 104:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 105:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(130);
      END_STATE();
    case 106:
      if (eof) ADVANCE(107);
      if (lookahead == '"') ADVANCE(115);
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(26);
      if (lookahead == ',') ADVANCE(109);
      if (lookahead == '.') ADVANCE(103);
      if (lookahead == '/') ADVANCE(20);
      if (lookahead == '0') ADVANCE(123);
      if (lookahead == ':') ADVANCE(111);
      if (lookahead == '[') ADVANCE(112);
      if (lookahead == ']') ADVANCE(113);
      if (lookahead == 'f') ADVANCE(28);
      if (lookahead == 'n') ADVANCE(91);
      if (lookahead == 't') ADVANCE(77);
      if (lookahead == '{') ADVANCE(108);
      if (lookahead == '}') ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ') SKIP(106)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(125);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '$') ADVANCE(70);
      if (lookahead == 'a') ADVANCE(67);
      if (lookahead == 'c') ADVANCE(53);
      if (lookahead == 'e') ADVANCE(72);
      if (lookahead == 'n') ADVANCE(89);
      if (lookahead == 'p') ADVANCE(73);
      if (lookahead == 's') ADVANCE(90);
      if (lookahead == 'w') ADVANCE(57);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(aux_sym_string_content_token1);
      if (lookahead == '*') ADVANCE(118);
      if (lookahead == '/') ADVANCE(120);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(121);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(aux_sym_string_content_token1);
      if (lookahead == '*') ADVANCE(117);
      if (lookahead == '/') ADVANCE(121);
      if (lookahead == '\n' ||
          lookahead == '"' ||
          lookahead == '\\') ADVANCE(22);
      if (lookahead != 0) ADVANCE(118);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(aux_sym_string_content_token1);
      if (lookahead == '*') ADVANCE(117);
      if (lookahead == '\n' ||
          lookahead == '"' ||
          lookahead == '\\') ADVANCE(22);
      if (lookahead != 0) ADVANCE(118);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(aux_sym_string_content_token1);
      if (lookahead == '/') ADVANCE(116);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ') ADVANCE(119);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(121);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(aux_sym_string_content_token1);
      if (lookahead == '"' ||
          lookahead == '\\') ADVANCE(135);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(120);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(aux_sym_string_content_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(121);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(126);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(100);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(99);
      if (lookahead == 'O' ||
          lookahead == 'o') ADVANCE(101);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(105);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(126);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(99);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.') ADVANCE(126);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(125);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(99);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '7')) ADVANCE(128);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(129);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(130);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_rule_constant_exactly);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(sym_rule_constant_prefix);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_rule_constant_suffix);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_rule_constant_equals_ignore_case);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(sym_rule_constant_wildcard);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(sym_rule_constant_anything_but);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(sym_rule_constant_numeric);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(sym_rule_constant_cidr);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(sym_rule_constant_exists);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym_rule_constant_or);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_DQUOTE_LT_DQUOTE);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_DQUOTE_GT_DQUOTE);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_DQUOTE_LT_EQ_DQUOTE);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_DQUOTE_GT_EQ_DQUOTE);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym_rule_numeric_equality_sign);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 13},
  [2] = {.lex_state = 0},
  [3] = {.lex_state = 0},
  [4] = {.lex_state = 13},
  [5] = {.lex_state = 13},
  [6] = {.lex_state = 13},
  [7] = {.lex_state = 13},
  [8] = {.lex_state = 13},
  [9] = {.lex_state = 13},
  [10] = {.lex_state = 14},
  [11] = {.lex_state = 14},
  [12] = {.lex_state = 1},
  [13] = {.lex_state = 0},
  [14] = {.lex_state = 0},
  [15] = {.lex_state = 0},
  [16] = {.lex_state = 0},
  [17] = {.lex_state = 0},
  [18] = {.lex_state = 0},
  [19] = {.lex_state = 0},
  [20] = {.lex_state = 1},
  [21] = {.lex_state = 0},
  [22] = {.lex_state = 1},
  [23] = {.lex_state = 0},
  [24] = {.lex_state = 0},
  [25] = {.lex_state = 0},
  [26] = {.lex_state = 0},
  [27] = {.lex_state = 0},
  [28] = {.lex_state = 0},
  [29] = {.lex_state = 0},
  [30] = {.lex_state = 0},
  [31] = {.lex_state = 0},
  [32] = {.lex_state = 0},
  [33] = {.lex_state = 0},
  [34] = {.lex_state = 0},
  [35] = {.lex_state = 0},
  [36] = {.lex_state = 0},
  [37] = {.lex_state = 0},
  [38] = {.lex_state = 13},
  [39] = {.lex_state = 0},
  [40] = {.lex_state = 0},
  [41] = {.lex_state = 0},
  [42] = {.lex_state = 0},
  [43] = {.lex_state = 0},
  [44] = {.lex_state = 0},
  [45] = {.lex_state = 0},
  [46] = {.lex_state = 0},
  [47] = {.lex_state = 0},
  [48] = {.lex_state = 13},
  [49] = {.lex_state = 13},
  [50] = {.lex_state = 13},
  [51] = {.lex_state = 0},
  [52] = {.lex_state = 0},
  [53] = {.lex_state = 0},
  [54] = {.lex_state = 0},
  [55] = {.lex_state = 0},
  [56] = {.lex_state = 0},
  [57] = {.lex_state = 0},
  [58] = {.lex_state = 0},
  [59] = {.lex_state = 0},
  [60] = {.lex_state = 0},
  [61] = {.lex_state = 0},
  [62] = {.lex_state = 0},
  [63] = {.lex_state = 0},
  [64] = {.lex_state = 0},
  [65] = {.lex_state = 0},
  [66] = {.lex_state = 0},
  [67] = {.lex_state = 13},
  [68] = {.lex_state = 0},
  [69] = {.lex_state = 0},
  [70] = {.lex_state = 0},
  [71] = {.lex_state = 13},
  [72] = {.lex_state = 0},
  [73] = {.lex_state = 13},
  [74] = {.lex_state = 13},
  [75] = {.lex_state = 0},
  [76] = {.lex_state = 0},
  [77] = {.lex_state = 0},
  [78] = {.lex_state = 0},
  [79] = {.lex_state = 0},
  [80] = {.lex_state = 13},
  [81] = {.lex_state = 0},
  [82] = {.lex_state = 0},
  [83] = {.lex_state = 0},
  [84] = {.lex_state = 0},
  [85] = {.lex_state = 0},
  [86] = {.lex_state = 0},
  [87] = {.lex_state = 13},
  [88] = {.lex_state = 0},
  [89] = {.lex_state = 0},
  [90] = {.lex_state = 0},
  [91] = {.lex_state = 0},
  [92] = {.lex_state = 0},
  [93] = {.lex_state = 0},
  [94] = {.lex_state = 0},
  [95] = {.lex_state = 0},
  [96] = {.lex_state = 0},
  [97] = {.lex_state = 0},
  [98] = {.lex_state = 0},
  [99] = {.lex_state = 0},
  [100] = {.lex_state = 13},
  [101] = {.lex_state = 0},
  [102] = {.lex_state = 0},
  [103] = {.lex_state = 0},
  [104] = {.lex_state = 0},
  [105] = {.lex_state = 0},
  [106] = {.lex_state = 0},
  [107] = {.lex_state = 0},
  [108] = {.lex_state = 0},
  [109] = {.lex_state = 0},
  [110] = {.lex_state = 0},
  [111] = {.lex_state = 0},
  [112] = {.lex_state = 0},
  [113] = {.lex_state = 0},
  [114] = {.lex_state = 0},
  [115] = {.lex_state = 0},
  [116] = {.lex_state = 0},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_rule_constant_exactly] = ACTIONS(1),
    [sym_rule_constant_prefix] = ACTIONS(1),
    [sym_rule_constant_suffix] = ACTIONS(1),
    [sym_rule_constant_equals_ignore_case] = ACTIONS(1),
    [sym_rule_constant_wildcard] = ACTIONS(1),
    [sym_rule_constant_anything_but] = ACTIONS(1),
    [sym_rule_constant_numeric] = ACTIONS(1),
    [sym_rule_constant_cidr] = ACTIONS(1),
    [sym_rule_constant_exists] = ACTIONS(1),
    [sym_rule_constant_or] = ACTIONS(1),
  },
  [1] = {
    [sym_document] = STATE(105),
    [sym__value] = STATE(114),
    [sym_object] = STATE(21),
    [sym_array] = STATE(21),
    [sym_string] = STATE(21),
    [anon_sym_LBRACE] = ACTIONS(5),
    [anon_sym_LBRACK] = ACTIONS(7),
    [anon_sym_DQUOTE] = ACTIONS(9),
    [sym_number] = ACTIONS(11),
    [sym_true] = ACTIONS(11),
    [sym_false] = ACTIONS(11),
    [sym_null] = ACTIONS(11),
    [sym_comment] = ACTIONS(3),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13), 1,
      anon_sym_RBRACE,
    ACTIONS(15), 1,
      anon_sym_DQUOTE,
    ACTIONS(17), 1,
      sym_number,
    ACTIONS(19), 1,
      sym_rule_constant_exactly,
    ACTIONS(21), 1,
      sym_rule_constant_prefix,
    ACTIONS(23), 1,
      sym_rule_constant_suffix,
    ACTIONS(25), 1,
      sym_rule_constant_equals_ignore_case,
    ACTIONS(27), 1,
      sym_rule_constant_wildcard,
    ACTIONS(29), 1,
      sym_rule_constant_anything_but,
    ACTIONS(31), 1,
      sym_rule_constant_numeric,
    ACTIONS(33), 1,
      sym_rule_constant_cidr,
    ACTIONS(35), 1,
      sym_rule_constant_exists,
    ACTIONS(37), 1,
      sym_rule_constant_or,
    STATE(33), 1,
      sym_pair,
    STATE(97), 1,
      sym_string,
    STATE(82), 11,
      sym_rule_value_matching,
      sym_rule_exactly_matching,
      sym_rule_prefix_matching,
      sym_rule_suffix_matching,
      sym_rule_equals_ignore_case_matching,
      sym_rule_wildcard_matching,
      sym_rule_anything_but_matching,
      sym_rule_numeric_matching,
      sym_rule_ip_address_matching,
      sym_rule_exists_matching,
      sym_rule_or_matching,
  [62] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(15), 1,
      anon_sym_DQUOTE,
    ACTIONS(17), 1,
      sym_number,
    ACTIONS(19), 1,
      sym_rule_constant_exactly,
    ACTIONS(21), 1,
      sym_rule_constant_prefix,
    ACTIONS(23), 1,
      sym_rule_constant_suffix,
    ACTIONS(25), 1,
      sym_rule_constant_equals_ignore_case,
    ACTIONS(27), 1,
      sym_rule_constant_wildcard,
    ACTIONS(29), 1,
      sym_rule_constant_anything_but,
    ACTIONS(31), 1,
      sym_rule_constant_numeric,
    ACTIONS(33), 1,
      sym_rule_constant_cidr,
    ACTIONS(35), 1,
      sym_rule_constant_exists,
    ACTIONS(37), 1,
      sym_rule_constant_or,
    STATE(64), 1,
      sym_pair,
    STATE(97), 1,
      sym_string,
    STATE(82), 11,
      sym_rule_value_matching,
      sym_rule_exactly_matching,
      sym_rule_prefix_matching,
      sym_rule_suffix_matching,
      sym_rule_equals_ignore_case_matching,
      sym_rule_wildcard_matching,
      sym_rule_anything_but_matching,
      sym_rule_numeric_matching,
      sym_rule_ip_address_matching,
      sym_rule_exists_matching,
      sym_rule_or_matching,
  [121] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LBRACE,
    ACTIONS(7), 1,
      anon_sym_LBRACK,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    ACTIONS(39), 1,
      anon_sym_RBRACK,
    STATE(37), 1,
      sym__value,
    STATE(21), 3,
      sym_object,
      sym_array,
      sym_string,
    ACTIONS(11), 4,
      sym_number,
      sym_true,
      sym_false,
      sym_null,
  [151] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LBRACE,
    ACTIONS(7), 1,
      anon_sym_LBRACK,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    ACTIONS(39), 1,
      anon_sym_RBRACK,
    ACTIONS(41), 1,
      sym_number,
    STATE(29), 1,
      sym_string,
    STATE(37), 1,
      sym__value,
    STATE(21), 2,
      sym_object,
      sym_array,
    ACTIONS(11), 3,
      sym_true,
      sym_false,
      sym_null,
  [185] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LBRACE,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    ACTIONS(43), 1,
      anon_sym_LBRACK,
    STATE(65), 1,
      sym__value,
    STATE(68), 1,
      sym__rule_value_array,
    STATE(21), 3,
      sym_object,
      sym_array,
      sym_string,
    ACTIONS(11), 4,
      sym_number,
      sym_true,
      sym_false,
      sym_null,
  [215] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LBRACE,
    ACTIONS(7), 1,
      anon_sym_LBRACK,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(69), 1,
      sym__value,
    STATE(21), 3,
      sym_object,
      sym_array,
      sym_string,
    ACTIONS(11), 4,
      sym_number,
      sym_true,
      sym_false,
      sym_null,
  [242] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LBRACE,
    ACTIONS(7), 1,
      anon_sym_LBRACK,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(65), 1,
      sym__value,
    STATE(21), 3,
      sym_object,
      sym_array,
      sym_string,
    ACTIONS(11), 4,
      sym_number,
      sym_true,
      sym_false,
      sym_null,
  [269] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    ACTIONS(45), 1,
      anon_sym_LBRACE,
    ACTIONS(47), 1,
      anon_sym_LBRACK,
    ACTIONS(49), 1,
      sym_number,
    STATE(57), 2,
      sym_string,
      sym__rule_value_array,
  [289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(53), 1,
      sym_rule_numeric_equality_sign,
    STATE(116), 1,
      sym_rule_numeric_comparison_sign,
    ACTIONS(51), 4,
      anon_sym_DQUOTE_LT_DQUOTE,
      anon_sym_DQUOTE_GT_DQUOTE,
      anon_sym_DQUOTE_LT_EQ_DQUOTE,
      anon_sym_DQUOTE_GT_EQ_DQUOTE,
  [305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(112), 1,
      sym_rule_numeric_comparison_sign,
    ACTIONS(51), 4,
      anon_sym_DQUOTE_LT_DQUOTE,
      anon_sym_DQUOTE_GT_DQUOTE,
      anon_sym_DQUOTE_LT_EQ_DQUOTE,
      anon_sym_DQUOTE_GT_EQ_DQUOTE,
  [318] = 6,
    ACTIONS(55), 1,
      anon_sym_DQUOTE,
    ACTIONS(57), 1,
      aux_sym_string_content_token1,
    ACTIONS(59), 1,
      sym_escape_sequence,
    ACTIONS(61), 1,
      sym_comment,
    STATE(22), 1,
      aux_sym_string_content_repeat1,
    STATE(100), 1,
      sym_string_content,
  [337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(63), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(65), 5,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_COLON,
      anon_sym_RBRACK,
  [359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(67), 4,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 4,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(71), 4,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(73), 4,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(75), 4,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [409] = 5,
    ACTIONS(61), 1,
      sym_comment,
    ACTIONS(77), 1,
      anon_sym_DQUOTE,
    ACTIONS(79), 1,
      aux_sym_string_content_token1,
    ACTIONS(82), 1,
      sym_escape_sequence,
    STATE(20), 1,
      aux_sym_string_content_repeat1,
  [425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(85), 4,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [435] = 5,
    ACTIONS(61), 1,
      sym_comment,
    ACTIONS(87), 1,
      anon_sym_DQUOTE,
    ACTIONS(89), 1,
      aux_sym_string_content_token1,
    ACTIONS(91), 1,
      sym_escape_sequence,
    STATE(20), 1,
      aux_sym_string_content_repeat1,
  [451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(93), 4,
      ts_builtin_sym_end,
      anon_sym_COMMA,
      anon_sym_RBRACE,
      anon_sym_RBRACK,
  [461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(97), 1,
      anon_sym_RBRACK,
    STATE(47), 1,
      aux_sym_rule_numeric_matching_repeat1,
  [474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    STATE(61), 1,
      sym_boolean,
    ACTIONS(99), 2,
      sym_true,
      sym_false,
  [485] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_COMMA,
    ACTIONS(103), 1,
      anon_sym_RBRACK,
    STATE(40), 1,
      aux_sym_rule_or_matching_repeat1,
  [498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(105), 1,
      anon_sym_COMMA,
    ACTIONS(108), 1,
      anon_sym_RBRACK,
    STATE(27), 1,
      aux_sym_rule_numeric_matching_repeat1,
  [511] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(110), 1,
      anon_sym_COMMA,
    ACTIONS(113), 1,
      anon_sym_RBRACK,
    STATE(34), 1,
      aux_sym__rule_value_array_repeat1,
  [524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(113), 1,
      anon_sym_RBRACK,
    ACTIONS(116), 1,
      anon_sym_COMMA,
    STATE(35), 1,
      aux_sym__rule_value_array_repeat2,
  [537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(121), 1,
      anon_sym_RBRACK,
    STATE(35), 1,
      aux_sym__rule_value_array_repeat2,
  [550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(121), 1,
      anon_sym_RBRACK,
    ACTIONS(123), 1,
      anon_sym_COMMA,
    STATE(34), 1,
      aux_sym__rule_value_array_repeat1,
  [563] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(125), 1,
      anon_sym_COMMA,
    ACTIONS(128), 1,
      anon_sym_RBRACK,
    STATE(32), 1,
      aux_sym_array_repeat1,
  [576] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(132), 1,
      anon_sym_RBRACE,
    STATE(41), 1,
      aux_sym_object_repeat1,
  [589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(123), 1,
      anon_sym_COMMA,
    ACTIONS(134), 1,
      anon_sym_RBRACK,
    STATE(42), 1,
      aux_sym__rule_value_array_repeat1,
  [602] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 1,
      anon_sym_COMMA,
    ACTIONS(134), 1,
      anon_sym_RBRACK,
    STATE(43), 1,
      aux_sym__rule_value_array_repeat2,
  [615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(136), 1,
      anon_sym_COMMA,
    ACTIONS(139), 1,
      anon_sym_RBRACE,
    STATE(36), 1,
      aux_sym_object_repeat1,
  [628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(143), 1,
      anon_sym_RBRACK,
    STATE(45), 1,
      aux_sym_array_repeat1,
  [641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(78), 1,
      sym_rule_value_matching,
    STATE(107), 1,
      sym_string,
  [654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_RBRACE,
    STATE(44), 1,
      aux_sym_rule_or_matching_repeat2,
  [667] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(101), 1,
      anon_sym_COMMA,
    ACTIONS(147), 1,
      anon_sym_RBRACK,
    STATE(46), 1,
      aux_sym_rule_or_matching_repeat1,
  [680] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(130), 1,
      anon_sym_COMMA,
    ACTIONS(149), 1,
      anon_sym_RBRACE,
    STATE(36), 1,
      aux_sym_object_repeat1,
  [693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(151), 1,
      anon_sym_COMMA,
    ACTIONS(154), 1,
      anon_sym_RBRACK,
    STATE(42), 1,
      aux_sym__rule_value_array_repeat1,
  [706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(156), 1,
      anon_sym_COMMA,
    ACTIONS(159), 1,
      anon_sym_RBRACK,
    STATE(43), 1,
      aux_sym__rule_value_array_repeat2,
  [719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(161), 1,
      anon_sym_COMMA,
    ACTIONS(164), 1,
      anon_sym_RBRACE,
    STATE(44), 1,
      aux_sym_rule_or_matching_repeat2,
  [732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      anon_sym_COMMA,
    ACTIONS(166), 1,
      anon_sym_RBRACK,
    STATE(32), 1,
      aux_sym_array_repeat1,
  [745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(168), 1,
      anon_sym_COMMA,
    ACTIONS(171), 1,
      anon_sym_RBRACK,
    STATE(46), 1,
      aux_sym_rule_or_matching_repeat1,
  [758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 1,
      anon_sym_COMMA,
    ACTIONS(173), 1,
      anon_sym_RBRACK,
    STATE(27), 1,
      aux_sym_rule_numeric_matching_repeat1,
  [771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(79), 1,
      sym_rule_value_matching,
    STATE(107), 1,
      sym_string,
  [784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    ACTIONS(175), 1,
      sym_number,
    STATE(30), 1,
      sym_string,
  [797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(83), 1,
      sym_string,
  [807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(177), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [815] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(179), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(181), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(183), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(185), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(21), 1,
      sym_rule_constant_prefix,
    STATE(113), 1,
      sym_rule_prefix_matching,
  [857] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(187), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(189), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(191), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(193), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(195), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [897] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(197), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LBRACE,
    STATE(26), 1,
      sym_object,
  [915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(139), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(199), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(201), 1,
      anon_sym_LBRACE,
    ACTIONS(203), 1,
      anon_sym_LBRACK,
  [941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(59), 1,
      sym_string,
  [951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(205), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(128), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(207), 1,
      anon_sym_LBRACK,
    ACTIONS(209), 1,
      sym_number,
  [977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(55), 1,
      sym_string,
  [987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(211), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(54), 1,
      sym_string,
  [1005] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(53), 1,
      sym_string,
  [1015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(213), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [1023] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(171), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [1031] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(215), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [1039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(164), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [1047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(145), 1,
      anon_sym_COMMA,
    STATE(39), 1,
      aux_sym_rule_or_matching_repeat2,
  [1057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(52), 1,
      sym_string,
  [1067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(159), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [1075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(217), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [1083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(219), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [1091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [1099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(223), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [1107] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(154), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [1115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9), 1,
      anon_sym_DQUOTE,
    STATE(81), 1,
      sym_string,
  [1125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(225), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [1133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      anon_sym_LBRACE,
    STATE(76), 1,
      sym_object,
  [1143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_LBRACK,
    STATE(68), 1,
      sym__rule_value_array,
  [1153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(227), 1,
      anon_sym_COLON,
  [1160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(229), 1,
      anon_sym_COMMA,
  [1167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(231), 1,
      sym_number,
  [1174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(233), 1,
      sym_number,
  [1181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(235), 1,
      anon_sym_COLON,
  [1188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(237), 1,
      anon_sym_COLON,
  [1195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(239), 1,
      anon_sym_COLON,
  [1202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(241), 1,
      sym_number,
  [1209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(243), 1,
      anon_sym_COLON,
  [1216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(245), 1,
      anon_sym_DQUOTE,
  [1223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(247), 1,
      anon_sym_COLON,
  [1230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(97), 1,
      anon_sym_RBRACK,
  [1237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(249), 1,
      anon_sym_COLON,
  [1244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(251), 1,
      anon_sym_COLON,
  [1251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(253), 1,
      ts_builtin_sym_end,
  [1258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(255), 1,
      anon_sym_COLON,
  [1265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(257), 1,
      anon_sym_COLON,
  [1272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(259), 1,
      anon_sym_COLON,
  [1279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(261), 1,
      anon_sym_COMMA,
  [1286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(263), 1,
      anon_sym_COLON,
  [1293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(265), 1,
      anon_sym_COLON,
  [1300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(267), 1,
      anon_sym_COMMA,
  [1307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(269), 1,
      anon_sym_RBRACE,
  [1314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(271), 1,
      ts_builtin_sym_end,
  [1321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(273), 1,
      sym_number,
  [1328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(275), 1,
      anon_sym_COMMA,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2)] = 0,
  [SMALL_STATE(3)] = 62,
  [SMALL_STATE(4)] = 121,
  [SMALL_STATE(5)] = 151,
  [SMALL_STATE(6)] = 185,
  [SMALL_STATE(7)] = 215,
  [SMALL_STATE(8)] = 242,
  [SMALL_STATE(9)] = 269,
  [SMALL_STATE(10)] = 289,
  [SMALL_STATE(11)] = 305,
  [SMALL_STATE(12)] = 318,
  [SMALL_STATE(13)] = 337,
  [SMALL_STATE(14)] = 348,
  [SMALL_STATE(15)] = 359,
  [SMALL_STATE(16)] = 369,
  [SMALL_STATE(17)] = 379,
  [SMALL_STATE(18)] = 389,
  [SMALL_STATE(19)] = 399,
  [SMALL_STATE(20)] = 409,
  [SMALL_STATE(21)] = 425,
  [SMALL_STATE(22)] = 435,
  [SMALL_STATE(23)] = 451,
  [SMALL_STATE(24)] = 461,
  [SMALL_STATE(25)] = 474,
  [SMALL_STATE(26)] = 485,
  [SMALL_STATE(27)] = 498,
  [SMALL_STATE(28)] = 511,
  [SMALL_STATE(29)] = 524,
  [SMALL_STATE(30)] = 537,
  [SMALL_STATE(31)] = 550,
  [SMALL_STATE(32)] = 563,
  [SMALL_STATE(33)] = 576,
  [SMALL_STATE(34)] = 589,
  [SMALL_STATE(35)] = 602,
  [SMALL_STATE(36)] = 615,
  [SMALL_STATE(37)] = 628,
  [SMALL_STATE(38)] = 641,
  [SMALL_STATE(39)] = 654,
  [SMALL_STATE(40)] = 667,
  [SMALL_STATE(41)] = 680,
  [SMALL_STATE(42)] = 693,
  [SMALL_STATE(43)] = 706,
  [SMALL_STATE(44)] = 719,
  [SMALL_STATE(45)] = 732,
  [SMALL_STATE(46)] = 745,
  [SMALL_STATE(47)] = 758,
  [SMALL_STATE(48)] = 771,
  [SMALL_STATE(49)] = 784,
  [SMALL_STATE(50)] = 797,
  [SMALL_STATE(51)] = 807,
  [SMALL_STATE(52)] = 815,
  [SMALL_STATE(53)] = 823,
  [SMALL_STATE(54)] = 831,
  [SMALL_STATE(55)] = 839,
  [SMALL_STATE(56)] = 847,
  [SMALL_STATE(57)] = 857,
  [SMALL_STATE(58)] = 865,
  [SMALL_STATE(59)] = 873,
  [SMALL_STATE(60)] = 881,
  [SMALL_STATE(61)] = 889,
  [SMALL_STATE(62)] = 897,
  [SMALL_STATE(63)] = 905,
  [SMALL_STATE(64)] = 915,
  [SMALL_STATE(65)] = 923,
  [SMALL_STATE(66)] = 931,
  [SMALL_STATE(67)] = 941,
  [SMALL_STATE(68)] = 951,
  [SMALL_STATE(69)] = 959,
  [SMALL_STATE(70)] = 967,
  [SMALL_STATE(71)] = 977,
  [SMALL_STATE(72)] = 987,
  [SMALL_STATE(73)] = 995,
  [SMALL_STATE(74)] = 1005,
  [SMALL_STATE(75)] = 1015,
  [SMALL_STATE(76)] = 1023,
  [SMALL_STATE(77)] = 1031,
  [SMALL_STATE(78)] = 1039,
  [SMALL_STATE(79)] = 1047,
  [SMALL_STATE(80)] = 1057,
  [SMALL_STATE(81)] = 1067,
  [SMALL_STATE(82)] = 1075,
  [SMALL_STATE(83)] = 1083,
  [SMALL_STATE(84)] = 1091,
  [SMALL_STATE(85)] = 1099,
  [SMALL_STATE(86)] = 1107,
  [SMALL_STATE(87)] = 1115,
  [SMALL_STATE(88)] = 1125,
  [SMALL_STATE(89)] = 1133,
  [SMALL_STATE(90)] = 1143,
  [SMALL_STATE(91)] = 1153,
  [SMALL_STATE(92)] = 1160,
  [SMALL_STATE(93)] = 1167,
  [SMALL_STATE(94)] = 1174,
  [SMALL_STATE(95)] = 1181,
  [SMALL_STATE(96)] = 1188,
  [SMALL_STATE(97)] = 1195,
  [SMALL_STATE(98)] = 1202,
  [SMALL_STATE(99)] = 1209,
  [SMALL_STATE(100)] = 1216,
  [SMALL_STATE(101)] = 1223,
  [SMALL_STATE(102)] = 1230,
  [SMALL_STATE(103)] = 1237,
  [SMALL_STATE(104)] = 1244,
  [SMALL_STATE(105)] = 1251,
  [SMALL_STATE(106)] = 1258,
  [SMALL_STATE(107)] = 1265,
  [SMALL_STATE(108)] = 1272,
  [SMALL_STATE(109)] = 1279,
  [SMALL_STATE(110)] = 1286,
  [SMALL_STATE(111)] = 1293,
  [SMALL_STATE(112)] = 1300,
  [SMALL_STATE(113)] = 1307,
  [SMALL_STATE(114)] = 1314,
  [SMALL_STATE(115)] = 1321,
  [SMALL_STATE(116)] = 1328,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(96),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [39] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [59] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [63] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 3),
  [65] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string, 2),
  [67] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 3),
  [69] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 3),
  [71] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 2),
  [73] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object, 4),
  [75] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 4),
  [77] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_content_repeat1, 2),
  [79] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_content_repeat1, 2), SHIFT_REPEAT(20),
  [82] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_content_repeat1, 2), SHIFT_REPEAT(20),
  [85] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value, 1),
  [87] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_content, 1),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(20),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [93] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array, 2),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [105] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rule_numeric_matching_repeat1, 2), SHIFT_REPEAT(11),
  [108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rule_numeric_matching_repeat1, 2),
  [110] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__value, 1), SHIFT(98),
  [113] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__value, 1), SHIFT(85),
  [116] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__value, 1), SHIFT(87),
  [119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(7),
  [128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_repeat1, 2),
  [130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(3),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_object_repeat1, 2),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [151] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__rule_value_array_repeat1, 2), SHIFT_REPEAT(98),
  [154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__rule_value_array_repeat1, 2),
  [156] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__rule_value_array_repeat2, 2), SHIFT_REPEAT(87),
  [159] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__rule_value_array_repeat2, 2),
  [161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rule_or_matching_repeat2, 2), SHIFT_REPEAT(38),
  [164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rule_or_matching_repeat2, 2),
  [166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [168] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rule_or_matching_repeat1, 2), SHIFT_REPEAT(89),
  [171] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rule_or_matching_repeat1, 2),
  [173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_anything_but_matching, 5, .production_id = 3),
  [179] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_prefix_matching, 3),
  [181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_suffix_matching, 3),
  [183] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_equals_ignore_case_matching, 3),
  [185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_wildcard_matching, 3),
  [187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_anything_but_matching, 3),
  [189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_numeric_matching, 3),
  [191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_ip_address_matching, 3),
  [193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean, 1),
  [195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_exists_matching, 3),
  [197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rule_numeric_matching_repeat1, 4),
  [199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 3, .production_id = 1),
  [201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_value_matching, 3, .production_id = 2),
  [207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_numeric_matching, 8),
  [213] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_numeric_matching, 7),
  [215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_or_matching, 6),
  [217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pair, 1),
  [219] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_exactly_matching, 3),
  [221] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rule_value_array, 4),
  [223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rule_value_array, 3),
  [225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_or_matching, 5),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [253] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(74),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rule_numeric_comparison_sign, 1),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_document, 1),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_eventrule(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
